#include <iostream>
#include <cstring>
#include <vector> 
#include <map> 
#include <set>
#include <algorithm>

using namespace std;

inline ostream& operator <<( ostream& out, const vector<char>& obj ) {
   for( auto p: obj ) cout << p;
   return out;
}

int main( void ) {
   char s[] = "The Life and Strange Surprizing Adventures of Robinson Crusoe, Of York, Mariner: \
       Who lived Eight and Twenty Years, all alone in an un-inhabited Island on the \
       Coast of America, near the Mouth of the Great River of Oroonoque; Having been \
       cast on Shore by Shipwreck, wherein all the Men perished but himself. With \
       An Account how he was at last as strangely deliver'd by Pyrates";
   vector<string> vs = { 
       "Supercalifragilisticexpialidocious",           // cамое длинное слово на английском языке
       "Pneumonoultramicroscopicsilicovolcanoconiosis" // самый длинный термин на английском языке 
   };
   // copy & find :
   vector<char> v1( strlen( s ) );
   copy( s, s + v1.size(), v1.begin() );
   int nb = 0;
   for( auto is = find( v1.begin(), v1.end(), ' ' ); is != v1.end();
             is = find( ++is, v1.end(), ' ' ) ) nb++;
   cout << "в фразе пробелов " << nb << " (" << nb + 1 << " слов)" << endl;
   // min & max :
   auto mm = minmax_element( v1.begin(), v1.end() );
   cout << "диапазон символов: '" << *mm.first << "' ... '" << *mm.second << "'" << endl;
   // fill & reverse & rotate & shuffle :
   vector<char> suv( vs[ 0 ].size() );
   copy( vs[ 0 ].begin(), vs[ 0 ].end(), suv.begin() );
   cout << suv << endl;
   random_shuffle( suv.begin(), suv.end() );
   cout << suv << endl;
   reverse( suv.begin(), suv.end() );
   cout << suv << endl;
   rotate( suv.begin(), suv.begin() + suv.size() / 2, suv.end() );
   cout << suv << endl;
   // set_intersection & set_difference 
   set< char > sus, pns;
   for( char s: vector<char>( vs[ 0 ].begin(), vs[ 0 ].end() ) ) sus.insert( s );
   for( char s: vector<char>( vs[ 1 ].begin(), vs[ 1 ].end() ) ) pns.insert( s );
   vector<char> outi( 100 ), outd( 100 );
   auto ret = set_intersection( sus.begin(), sus.end(), pns.begin(), pns.end(), outi.begin() );
   cout << "общих литер " << ( ret - outi.begin() ) << " : " << outi << endl;
   ret = set_difference( sus.begin(), sus.end(), pns.begin(), pns.end(), outd.begin() );
   cout << "уникальных литер " << ( ret - outd.begin() ) << " : " << outd << endl;
}

