#include <iostream>
#include <vector>
#include <sstream>
#include <numeric>
#include <cmath>
using namespace std;

double amean;

double disp( double acc, double seq ) {
   seq -= amean;
   return acc + seq * seq;
}

double mul( double acc, double seq ) {
   return acc * seq;
}

double garm( double acc, double seq ) {
   return acc + 1. / seq;
}

double sqr( double acc, double seq ) {
   return acc + seq * seq;
}

int main( void ) { 
   string s;
   getline( cin, s );
   istringstream ist( s );
   double d; 
   vector<double> ser;
   while( ist >> d )
      ser.push_back( d );
   int n = ser.size();
   auto b = ser.begin(), e = ser.end();
   amean = accumulate( b, e, 0. ) / n;
   double variance = accumulate( b, e, 0., disp ) / n,
          deviation = sqrt( variance ),
          gmean = exp( log( accumulate( b, e, 1., mul ) ) / n ),
          rmean = n / accumulate( b, e, 0., garm ),
          smean = sqrt( accumulate( b, e, 0., sqr ) / n );
   cout << "ср.ариф.=" << amean << " ср.геом.=" << gmean
        << " ср.гарм.=" << rmean << " ср.квад.=" << smean << endl
        << "дисперсия=" << variance << " СКО=" << deviation << endl;
}
