#include <iostream>
#include <vector>
#include <algorithm>
#include <future>
using namespace std;

struct data {                                  // запись о студенте
   string fio;
   uint group, age, scholarship;
   data( string fio, uint group, uint age, uint scholarship = 0 )
      : fio( fio ), group( group ), age( age ), scholarship( scholarship ) {
      cout << '+'; }
   data( const data& d )
      : fio( d.fio ), group( d.group ), 
        age( d.age ), scholarship( d.scholarship ) {
      cout << '+'; }
   ~data( void ) { cout << '-'; }
   inline friend ostream& operator <<( ostream& out, const data& obj ) {
      return out << "[ " << obj.fio << " : " << obj.group << " : " 
                 << obj.age << " : " << obj.scholarship << " ]";
   } 
};

struct comp_data {                             // функтор сравнения
   int what;
   bool compare( const data& f, const data& s ) {
      switch( abs( what ) ) {
         case 1: return f.fio < s.fio;
         case 2: return f.group < s.group;
         case 3: return f.age < s.age;
         case 4: return f.scholarship < s.scholarship;
         default: return false;
      }
   }
public: 
   comp_data( int what ) : what( what ) {} 
   bool operator()( const shared_ptr< data > f, const shared_ptr< data > s ) {
      bool ret = compare( *f, *s );
      return what >= 0 ? ret : !ret;
   }
};

int main( void ) {
   data list[] = {
      { "Сидоров С.С.", 12, 19, 1500 },
      { "Иванов И.И.",  13, 20 },
      { "Петров П.П.",  11, 21 },
      { "Чапаев В.И.",  10, 45, 2000 },
   };
   cout << endl;
   vector< shared_ptr< data > > filology;
   for( unsigned i = 0; i < sizeof( list ) / sizeof( list[ 0 ] ); i++ ) {
      filology.push_back( shared_ptr< data >( new data( list[ i ] ) ) );
   }
   cout << endl;
   while( true ) {
      for( auto x : filology ) cout << *x << endl;
      cout << "поле сортировки? : ";
      int mode;
      cin >> mode;
      if( !cin || ( cin.rdstate() & ios::eofbit ) ) {
         cout << endl;
         break;
      }
      sort( filology.begin(), filology.end(), comp_data( mode ) );
   }
   auto i = filology.begin();
   while( i != filology.end() ) {  // filology.clear();
      filology.erase( i ); 
   }
   cout << "размер журнала = " << filology.size()  << endl; 
}
