#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct data {                                  // запись о студенте
   string fio;
   uint group, age, scholarship;
   inline friend ostream& operator <<( ostream& out, const data& obj ) {
      return out << "[ " << obj.fio << " : " << obj.group << " : " 
                 << obj.age << " : " << obj.scholarship << " ]";
   } 
};

struct comp_data {                             // функтор сравнения
   int what;
   bool compare( const data& f, const data& s ) {
      switch( abs( what ) ) {
         case 1: return f.fio < s.fio;
         case 2: return f.group < s.group;
         case 3: return f.age < s.age;
         case 4: return f.scholarship < s.scholarship;
         default: return false;
      }
   }
public: 
   comp_data( int what ) : what( what ) {} 
   bool operator()( const data& f, const data& s ) {
      bool ret = compare( f, s );
      return what >= 0 ? ret : !ret;
   }
};

class faculty : public vector<struct data> {   // журнал
public:
   faculty( const vector<struct data>& ini ) {
      for( auto &x : ini ) this->push_back( x );
   }
   inline friend ostream& operator <<( ostream& out, const faculty& obj ) {
      for( auto &x : obj ) out << x << endl;
      return out;
   }
};

int main( void ) {
   faculty filology = ( vector< data > ( {  
      { "Сидоров С.С.", 12, 19, 1500 },
      { "Иванов И.И.",  13, 20 },
      { "Петров П.П.",  11, 21 },
      { "Чапаев В.И.",  10, 45, 2000 },
   } ) );
   while( true ) {
      cout << filology;
      cout << "поле сортировки? : ";
      int mode;
      cin >> mode;
      if( !cin || ( cin.rdstate() & ios::eofbit ) ) {
         cout << endl;
         break;
      }
      sort( filology.begin(), filology.end(), comp_data( mode ) );
   }
}
