#include <iostream>
#include <vector>
#include <climits>
using namespace std;

void put( const vector<float>& v ) {
   cout << "capacity=" << v.capacity() 
        << ", size="   << v.size() << " : ";
   for( uint i = 0; i < v.size(); i++ )
      cout << v[ i ] << " ";
   cout << endl;
}

vector<float>& operator +=( vector<float>& v, uint n ) {
   float last = v[ v.size() - 1 ];
   for( uint i = 0; i < n; i++ )
      v.push_back( last + i + 1 );
   return v;
}

int main( void ) { 
   float data[] = { 1., 2., 3., 4., 5., 6., 7. };
   int n = sizeof( data ) / sizeof( data[ 0 ] );
   vector<float> array( data, data + n );
   cout << "max_size=" << array.max_size() 
        << "  ((INT_MAX+1)/2)=" << ( (uint)INT_MAX + 1 ) / 2 << endl;
   put( array );
   put( array += 2 );
   put( array += 6 );
   return 0;
}
